/************************************************************************/
/*                                                                      */
/* Copyright (C) 1997 Arve Kylling                                      */
/*                                                                      */
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 1, or (at your option)  */
/* any later version.                                                   */
/*                                                                      */
/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY of FITNESS FOR A PARTICULAR PURPOSE. See the         */
/* GNU General Public License for more details.                         */
/*                                                                      */
/* To obtain a copy of the GNU General Public License write to the      */
/* Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,   */
/* USA.                                                                 */
/*----------------------------------------------------------------------*/
/************************************************************************/

#ifndef __ancillary_h
#define __ancillary_h

#include <stdio.h>
#include "uvspec.h"

int setup_wlgrid (input_struct input, output_struct *output);
int arb_wvn( int n_old_x, float *old_x, float *old_y,  
	      int n_new_x, float *new_x, float *new_y, int linear);
int set_transmittance_wl_grid(wl_inp_struct *wl_inp, wl_out_struct *wl_out);

int convolve(input_struct input, output_struct *output);
int spline_interpolate(input_struct input, output_struct *output);

int interpolate_transmittance (input_struct input, output_struct *output);
int multiply_extraterrestrial (input_struct input, output_struct *output);
int crs_rayleigh(float* lambda, int n_lambda, float ***crs );
int optical_properties (input_struct input, output_struct *output, int iv, int iq);
int integrate3D (input_struct input, output_struct *output);

#endif



